var wscmd,wsnotify;
var toDownload=true,vpnEnable=1,autoLaunchSta=1,MP_manual_disconnect=false,up101=false;
function sleep(d){for(var t=Date.now();Date.now()-t<=d;);}
var cookies_vpn={role:'',acs_mode:'',acs_desc:''};
var MotionPro={
	port_list:[60012,60014],
	MP_exist:false,
	once:true,
	vpn_sta:{
		connecting:"正在连接...",
		connected:"L3VPN已连接",
		disconnecting:"断开LVPN ...",
		reconnecting:"正在重连 ...",
		failed:"L3VPN连接失败",
		disconnected:"L3VPN已断开",
		idle:"VPN 空闲",
		updating_100:"正在升级MotionPro客户端组件管理器, 请等待 ...",
		updating_101:"正在升级MotionPro客户端初始化程序，请等待 ...",
		updating_102:"正在升级MotionPro客户端核心组件，请等待 ...",
		updating_103:"正在升级MotionPro界面组件，请等待 ...",
		updating_104:"正在升级MotionPro编译器核心组件，请等待 ...",
		updating_200:"MotionPro客户端升级完成"
	},
	init:function(){this.websocketInit(60012);},
    websocketInit:function(port){
		var wsInitConnected=0,wsInitCheckTimer,cmdUrl,notifyUrl,newVersion=false;
		console.log('detect MotionPro...');
        cmdUrl='wss://127.0.0.1:'+port+'/ws/command';
        notifyUrl='wss://127.0.0.1:'+port+'/ws/notify';
        wscmd=new WebSocket(cmdUrl);
        wsnotify=new WebSocket(notifyUrl);
        wsInitCheckTimer=setTimeout(checkWebSocketStatus,1500);

		wscmd.onopen=function(event){
			console.log("ws command onopen");
			wsInitConnected+=1;
			if(wsInitConnected==2){
				clearTimeout(wsInitCheckTimer);
				MotionPro.MP_exist=true;
				statusInit();
			}
		};
		wscmd.onmessage=function(event){
			console.log("ws command onmessage: "+event.data);
			showCommandResponseMessage(event.data);
		};
		wscmd.onclose=function(event){
			console.log("ws command onclose: "+event.data);
			wsInitConnected = 0;
			console.log("close ws");            
			if(up101||typeof(checkStatus)!='undefined'){
				console.log("timer for update init");
				setTimeout(update_wsinit,5000);
			}
		};
		wscmd.onerror=function(event){
			console.log("ws command onerror: "+event.data);
			clearTimeout(wsInitCheckTimer);
			wsInitConnected=0;
			onWebsocketConnectError();
		};
		wsnotify.onopen=function(event){
			console.log("ws notify onopen");
			wsInitConnected+=1;
			if(wsInitConnected==2){
				clearTimeout(wsInitCheckTimer);
				MotionPro.MP_exist = true;
				statusInit();
			}
		};
		wsnotify.onmessage=function(event){
			console.log("\n---------------------------------\n");
			console.log("ws notify onmessage: "+event.data);
			showCallbackMessage(event.data);
		};
		wsnotify.onclose=function(event){
			console.log("ws notify onclose: "+event.data);
			wsInitConnected=0;
		};
		wsnotify.onerror=function(event){
			console.log("ws notify onerror: "+event.data);
			wsInitConnected=0;
		};
        function onWebsocketConnectError(){
            if(MotionPro.port_list.indexOf(port)>-1&&port!==60014){
                port+=2;
                MotionPro.websocketInit(port);
			}else{
				if(typeof(_AN_motionpro_detect_prelogin)=='undefined'||!_AN_motionpro_detect_prelogin){
					if(toDownload){
                        //downLoadMP();
						$('#vpnBtn').addClass('hide');$('#vpnOn').removeClass('hide');
						toDownload=false;
					}
				}
			}
		}
		function downLoadMP(){
			console.log('Dont detect MP client');
			window.location.href="/prx/000/http/localhost/login/download.html";
		}
		function checkWebSocketStatus(){
			var ok=true;
			if(wscmd.readyState!=WebSocket.OPEN) {
				console.log("ws command not ready!");
				ok=false;
			}
			if(wsnotify.readyState!=WebSocket.OPEN) {
				console.log("ws notify not ready!");
				ok=false;
			}
			if(!ok){
				wscmd.close();
				wsnotify.close();
				onWebsocketConnectError();
			}
		}
		function getStatus(){
			console.log("getStatus");
			if(wsInitConnected==0) {
				console.log("getStatus, but wsInitConnected == 0");
				location.reload();
			}
			var msg={
				error:0,
				message:"get vpn status from js",
				action:8,
				data:{action:8}
			};
			newVersion||wscmd.send(JSON.stringify(msg));
		}
		function showCommandResponseMessage(data){
            if(data==null){console.log("response msg is empty!");return;}
			var msg=JSON.parse(data);
			if(typeof(msg)!="object"){console.log("response msg is not object!");return;}
			if(msg.action==6){//start
				if(!msg.error&&!newVersion){
					showMsg(MotionPro.vpn_sta.connecting);
					setTimeout(getStatus,4000);
				}
				return;
			}
            if(msg.action==7){//stop
				if(!msg.error){                
					showMsg(MotionPro.vpn_sta.disconnecting);
					setTimeout(getStatus,4000);
				}
				return;
			}
			if (msg.action==undefined&&msg.data!=undefined&&msg.data.action!=undefined){msg.action=msg.data.action;}
			if(msg.action!==8){console.log("not a status response msg!");return;}
			var messages={};
			messages["-1"]=MotionPro.vpn_sta.failed;
			messages["0"]=MotionPro.vpn_sta.idle;
			messages["1"]=MotionPro.vpn_sta.connecting;
			messages["2"]=MotionPro.vpn_sta.connected;
			messages["3"]=MotionPro.vpn_sta.disconnecting;
			messages["4"]=MotionPro.vpn_sta.reconnecting;
			messages["7"]=MotionPro.vpn_sta.disconnected;
			messages["100"]=MotionPro.vpn_sta.updating_100;
			messages["101"]=MotionPro.vpn_sta.updating_101;
			messages["102"]=MotionPro.vpn_sta.updating_102;
			messages["103"]=MotionPro.vpn_sta.updating_103;
			messages["104"]=MotionPro.vpn_sta.updating_104;
			messages["200"]=MotionPro.vpn_sta.updating_200;
			var key=msg.data.status.toString();
			var host=msg.data.site.host;
			var site=msg.data.site.name;
			if(key in messages){
				if(site.length>0){showMsg("站点: "+site+"["+host+"]");}
				if(key!='1'&& parseInt(key)<100&&typeof(checkStatus)!='undefined'){clearTimeout(checkStatus);}
				if(key!='0'&&key!='-1'&&key!='7'){showMsg(messages[key]);}
				if(key=='2'){//connected
					var url=window.location.search.substring(5);
					$.ajax({
						url:url,
						timeout:5000,
						dataType:'jsonp',
						async:true,
						complete:function(xhr){
							if(xhr.readyState===4&&xhr.status===200){window.location.replace(url);}else{
								console.log('connect '+url+' timedout');
								window.location.replace(url);
							}
						}
					});
					$('#vpnOn').addClass('hide').removeAttr('disabled');
					$('#vpnOff').removeClass('hide').removeAttr('disabled');
					clearMsg();
				}else if(key == '0'||key == '-1'||key == '7'){//idle
					$('#vpnOff').addClass('hide'); 
					$('#vpnOn').removeClass('hide');
					(key=='7')&&clearMsg();
					//autoLaunch();
				}else if(parseInt(key)>99){//update
					$('#vpnOff').attr('disabled', 'disabled')
					$('#vpnOn').attr('disabled', 'disabled');
					if(key=='101'){
						console.log('command 101');
						up101=true;
					}
				}
			}else{
				console.log("response msg not valid!");
			}
		}
		function showCallbackMessage(data){
			if(data==null){
				console.log("callback msg is empty!");
				return;
			}
			var msg=JSON.parse(data);
			if(typeof(msg)!="object"){console.log("callback msg is not object!");return;}
			if(msg.data.action!==10){console.log("invalid callback msg!");return;}
			var messages={};
			messages["1"] = MotionPro.vpn_sta.connecting;
			messages["2"] = MotionPro.vpn_sta.failed;
			messages["3"] = MotionPro.vpn_sta.connected;
			messages["4"] = MotionPro.vpn_sta.disconnecting;
			messages["5"] = MotionPro.vpn_sta.disconnected;
			messages["7"] = MotionPro.vpn_sta.reconnecting;            
			messages["100"] = MotionPro.vpn_sta.updating_100;
			messages["101"] = MotionPro.vpn_sta.updating_101;
			messages["102"] = MotionPro.vpn_sta.updating_102;
			messages["103"] = MotionPro.vpn_sta.updating_103;
			messages["104"] = MotionPro.vpn_sta.updating_104;
			messages["200"] = MotionPro.vpn_sta.updating_200;
			var key=msg.data.callback.toString();
			(key=='2')&&$('#vpnOn').removeAttr('disabled');

			if(key=='32'||parseInt(key)>99){
				$('#vpnOn').attr('disabled');
				$('#vpnOff').addClass('hide').removeAttr('disabled');               
				$('#vpnBtn').addClass('hide').text('正在升级 ...').attr('disabled', 'disabled');
				if(key=='101'){
					console.log('callback 101');
					up101=true;
				}
				showMsg(messages[key]);
			}else if(key=='33'){
				console.log('logout');
				setTimeout("window.location.href = '/prx/000/http/localhost/logout/index.html'",4000);
			} 
			if(true){
				if(key in messages){
					showMsg(messages[key]);
					if(key=='3'){//connected
						var url=window.location.search.substring(5);
						$.ajax({
						url:url,
						timeout:5000,
						dataType:'jsonp',
						async:true,
						complete:function(xhr){
							if(xhr.readyState===4&&xhr.status===200){window.location.replace(url);}else{
								console.log('connect '+url+' timedout');
								window.location.replace(url);
							}
						}
						});
						clearMsg();
						if(typeof(checkStatus)!='undefined'){clearTimeout(checkStatus);}
					}else if(key=='5'){//disconnected
						clearMsg();
						$('#loading').html(MotionPro.vpn_sta.disconnected);
					}else if(key=='2'){//failed
						$('#vpnMsg').addClass('errorMsg');
						$('#loading').html(MotionPro.vpn_sta.failed);
					}else{
						$('#vpnMsg').removeClass('errorMsg');
					}
				}else{
					console.log("invalid callback msg!");
				}
			}
		}
		function showMsg(str){$('#vpnMsg').text(str);}
		function clearMsg(){showMsg('');}
		function statusInit(){getStatus();}
		function autoLaunch(){
			if(MotionPro.once&&autoLaunchSta=='1'&&!MP_manual_disconnect){
				console.log('Auto Launch');
				MotionPro.startVpn();
				MotionPro.once=false;
			}
		}
	},
	detectMP:function(){
		if(!MotionPro.MP_exist){
			console.log('Pls install MP client');
			window.location.href="/prx/000/http/localhost/login/download.html";
			return false;
		}
		return true;
	},	
	mobileDetect:function(str){
		var ua=detect.parse(navigator.userAgent);
		var os=ua.os.family;
		return (os.indexOf('Android')>-1||os.indexOf('iOS')>-1);
	},
	getStatus4Timer:function(){
		console.log("getStatus4Timer");
		var msg={
			error:0,
			message:"get vpn status from js",
			action:8,
			data:{action: 8}
		};
		wscmd.send(JSON.stringify(msg));
		checkStatus=setTimeout(MotionPro.getStatus4Timer,2000);
	},
	getCookie:function(name){
		var arr=document.cookie.match(new RegExp('(^| )'+name+'=([^;]*)(;|$)'));
		return (arr!=null)?decodeURIComponent(arr[2]):arr;
    },
    getRole:function(){
		var rn=this.getCookie('role_names');
		cookies_vpn.role=rn?rn:'';
	},    
	getAcsMode:function(){
		var am=this.getCookie('acs_mode');
		cookies_vpn.acs_mode=am?am:'';
	},
    getAcsDesc:function(){
		var ad=this.getCookie('acs_desc');
		cookies_vpn.acs_desc=ad?ad.replace(/\+/g,' '):'';
	},
	startVpn:function(){
		if(MotionPro.detectMP()){
			console.log('start VPN');
			setTimeout(MotionPro.getStatus4Timer,4000);
			var allCookies=Cookies.get();
			var sessionPrefix="ANsession";
			var sessionCookie="";
			for(var key in allCookies){
				if(key.substr(0,sessionPrefix.length)==sessionPrefix){sessionCookie=key+"="+allCookies[key];}
			}
			var port=443;
			if(window.location.port.length>0){port=parseInt(window.location.port);}
			var vc="cs_postlogin_enable=";
			if(typeof(_AN_clientsecurity_postlogin_enable)!='undefined' &&_AN_clientsecurity_postlogin_enable){
				vc+="true@cs_postlogin_interval=";
			} else {
				vc+="false@cs_postlogin_interval=";
			}
			if(typeof(_AN_clientsecurity_postlogin_interval)!='undefined'){
				vc+=_AN_clientsecurity_postlogin_interval;
			}else{
				vc+="300";
			}
			MotionPro.getRole();
			MotionPro.getAcsMode();
			MotionPro.getAcsDesc();
			if(cookies_vpn.acs_mode!=''){
				vc+="@role_names="+cookies_vpn.role+"&acs_mode="+cookies_vpn.acs_mode+"&acs_desc="+cookies_vpn.acs_desc;
			}else{
				vc+="";
			}
			console.log("validcode:"+vc);
			var msg={
				error:0,
				action:6,
				message:"start vpn msg from js",
				data:{
					action:6,
					site:{
						name:"",
						host:window.location.hostname,
						session:sessionCookie,
						port:port,
						server_type:2,
						flags:0,
						username:_AN_username,
						validcode:vc,
					}
				}
			};
			wscmd.send(JSON.stringify(msg));
		}
	},
	stopVpn:function(){
		$('#vpnOff').attr('disabled','disabled');
		console.log('stop VPN');
		MP_manual_disconnect=true;
		var msg={
			error:0,
			action:7,
			message:"stop vpn msg from js",
			data:{action:7}
		};
		wscmd.send(JSON.stringify(msg));
	}, 
	stopConfirm:function(){}
};
function update_wsinit(){
	console.log('start ws init for updating');
	$('#vpnMsg').text('');
	MotionPro.init();
	setTimeout(MotionPro.getStatus4Timer,1000);
}
function MP_init(){
	$('#vpnOn').addClass('hide');
	$('#vpnOff').addClass('hide');
	$('#vpnBtn').addClass('hide');
	if(vpnEnable){
		if(_AN_str_startvpn=='连 接'){
			$('#vpnOn').text('启动连接').on('click',MotionPro.startVpn);
		}else{
			$('#vpnOn').text(_AN_str_startvpn).on('click',MotionPro.startVpn);
		}
		$('#vpnOff').text('断开连接').on('click',MotionPro.stopVpn);
		MotionPro.init();
		if(!MotionPro.mobileDetect()){setTimeout(MotionPro.startVpn,1000);}//PC
	}
}
$(window).on('unload',
	function(){
		try{
			if(typeof(checkStatus)!='undefined'){clearTimeout(checkStatus);}
			wsnotify.close();wscmd.close();
			console.log("websocket closed.");
		}catch(e){
			console.log(e);
		}
});
$(window).on('beforeunload',
	function(){
		try{
			if(typeof(checkStatus)!='undefined'){clearTimeout(checkStatus);}
            wsnotify.close();wscmd.close();
            console.log("websocket closed.");
        }catch(e){
            console.log(e);
        }
});